<?php

namespace AppBundle\Repository\Content;

use AppBundle\Entity\Content\Comment;
use AppBundle\Entity\Content\Proposal;

/**
 * CommentRepository
 *
 * This class was generated by the Doctrine ORM. Add your own custom
 * repository methods below.
 */
class CommentRepository extends \Doctrine\ORM\EntityRepository
{
    public function queryComments(Proposal $proposal = null)
    {
        $qb = $this->createQueryBuilder('p');
        if($proposal) {
            $qb->leftJoin('p.referedProposal', 's');
        }
        $qb->where('p.status = :status')
            ->setParameter('status', Comment::STATUS_OPEN);
        if($proposal) {
            $qb->andWhere('s.id = :proposal')
                ->setParameter('proposal', $proposal->getId());
        }
        $qb->orderBy('p.createdAt', 'DESC');

        return $qb;
    }
}
